<?php
namespace Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification; 

class Fai02800LancDespMaoController extends \Teknisa\Libs\Controller\CRUD {

    protected $entityManager;
    protected $connection;
    protected $environment;
    
    public function __construct($crudService, $environment, $entityManager, $connection) {
        $this->entityManager = $entityManager;
        $this->connection = $connection;
        parent::__construct($crudService, $environment);
    }
    
    public function atualizaLancDesp(DTO\Request $request, DTO\Response $response){
        
        $data = $request->getDataSet();
        
        $rows = $data->getRows();
        foreach($rows as $row){
            $dados[0] = $row[0];
            $dados[1] = $row[1];
        }

        
        if($dados != null){
            $impostoBackupRow = $dados[0];
            $impostoCurrentRow  = $dados[1];
            try{
                $stmt = $this->connection->prepare("UPDATE LANCDESPFATU
                 SET
                   DTLANCDESFAT = :P_DTLANCDESFAT_NOVO,
                   VRPREVDESFAT = :P_VRPREVDESFAT,
                   VRLANCDESFAT = :P_VRLANCDESFAT,
                   VRTXLANCDESP = :P_VRTXLANCDESP
                 WHERE
                   CDDESPADMFAT = :P_CDDESPADMFAT   AND
                   DTLANCDESFAT = :P_DTLANCDESFAT AND
                   CDFILIAL     = :P_CDFILIAL");
                $stmt->execute(
                    array(
                        'P_DTLANCDESFAT_NOVO' => $impostoCurrentRow["DTLANCDESFAT"],
                        'P_CDDESPADMFAT'      => $impostoBackupRow["CDDESPADMFAT"],
                        'P_DTLANCDESFAT'      => $impostoBackupRow["DTLANCDESFAT"],
                        'P_CDFILIAL'          => $impostoBackupRow["CDFILIAL"],
                        'P_VRPREVDESFAT'      => $impostoCurrentRow["VRPREVDESFAT"],
                        'P_VRLANCDESFAT'      => $impostoCurrentRow["VRLANCDESFAT"],
                        'P_VRTXLANCDESP'      => $impostoCurrentRow["VRTXLANCDESP"],
                        
                    )
                );
            }catch(\Exception $ex){

                if(strpos($ex->getMessage(), "ORA-00001") === FALSE){
                    $response->setError(new Error($ex->getMessage(), 500));
                }else{
                    $response->setError(new Error("DUPLICIDADE", 500));
                }
            }
        }
    }
}